#include "../system/coordinates.h"
#include "../system/utilities.h"
#include "piece.h"
#include "bishop.h"
#include <vector>
#include <iostream>

/// @brief calculate a list of empty space coordinates needed for the move to be legal, assuming the move is possible
/// @param dest destination coordinates
/// @return a vector containing all coordinates to be verified
void bishop::needed_space(coordinates dest, std::vector<coordinates> *to_calculate){
    int diff_x = dest.get_x() - piece::coord.get_x();
    int diff_y = dest.get_y() - piece::coord.get_y();
    int coord_x = -1;
    int coord_y = -1;
    for(int i = 1; i < abs(diff_x); i++){
        if(diff_x > 0){
            coord_x = piece::coord.get_x() + i;
        }else{
            coord_x = piece::coord.get_x() - i;
        }
        if(diff_y > 0){
            coord_y = piece::coord.get_y() + i;
        }else{
            coord_y = piece::coord.get_y() - i;
        }
        to_calculate->push_back(coordinates(coord_x,coord_y));
    }
}

/// @brief print the piece to the standard output
void bishop::print_piece(){
    if(piece::white){
        std::cout << "\u2657";
    }else{
        std::cout << "\u265D";
    }
}

/// @brief print the piece to the standard output in canonical form
void bishop::canonical_print_piece(){
    if(piece::white){
        std::cout << "wB";
    }else{
        std::cout << "bB";
    }
}