#ifndef BISHOP
#define BISHOP
#include "../system/coordinates.h"
#include "../system/utilities.h"
#include "piece.h"
#include <vector>

/// @brief the bishop piece class.
class bishop : public piece{
    public:
        bishop(bool _white, coordinates _coord):
            piece(_white,_coord)
            {
                type = bishop_type;
                for(int i = -7; i < 8; i++)
                    if(i!=0){
                        legals.push_back(coordinates(i,i));
                        legals.push_back(coordinates(i,-i));
                    }
            }
        void needed_space(coordinates dest, std::vector<coordinates> *to_calculate) override;
        void print_piece() override;
        void canonical_print_piece() override;
};

#endif