#include "../system/coordinates.h"
#include "../system/utilities.h"
#include "piece.h"
#include "king.h"
#include <vector>
#include <iostream>

/// @brief calculate a list of empty space coordinates needed for the move to be legal, assuming the move is possible
/// @param dest destination coordinates
/// @return a vector containing all coordinates to be verified
void king::needed_space(coordinates dest, std::vector<coordinates> *to_calculate){
    // The king doesn't need space
}

/// @brief print the piece to the standard output
void king::print_piece(){
    if(piece::white){
        std::cout << "\u2654";
    }else{
        std::cout << "\u265A";
    }
}

/// @brief print the piece to the standard output in canonical form
void king::canonical_print_piece(){
    if(piece::white){
        std::cout << "wK";
    }else{
        std::cout << "bK";
    }
}