#ifndef KNIGHT
#define KNIGHT
#include "../system/coordinates.h"
#include "../system/utilities.h"
#include "piece.h"
#include <vector>

/// @brief the knight piece class.
class knight : public piece{
    public:
        knight(bool _white, coordinates _coord):
            piece(_white,_coord)
            {
                type = knight_type;
                legals.push_back(coordinates(2,1));
                legals.push_back(coordinates(2,-1));
                legals.push_back(coordinates(-2,1));
                legals.push_back(coordinates(-2,-1));
                legals.push_back(coordinates(1,2));
                legals.push_back(coordinates(-1,2));
                legals.push_back(coordinates(1,-2));
                legals.push_back(coordinates(-1,-2));
            }
        void needed_space(coordinates dest, std::vector<coordinates> *to_calculate) override;
        void print_piece() override;
        void canonical_print_piece() override;
};

#endif