#ifndef QUEEN
#define QUEEN
#include "../system/coordinates.h"
#include "../system/utilities.h"
#include "piece.h"
#include <vector>

/// @brief the queen piece class.
class queen : public piece{
    public:
        queen(bool _white, coordinates _coord):
            piece(_white,_coord)
            {
                type = queen_type;
                for(int i = -7; i < 8; i++)
                    if(i!=0){
                        // Bishop moves
                        legals.push_back(coordinates(i,i));
                        legals.push_back(coordinates(i,-i));
                        // Rook moves
                        legals.push_back(coordinates(0,i));
                        legals.push_back(coordinates(i,0));
                    }
            }
        void needed_space(coordinates dest, std::vector<coordinates> *to_calculate) override;
        void print_piece() override;
        void canonical_print_piece() override;
};

#endif