#include "../system/coordinates.h"
#include "../system/utilities.h"
#include "piece.h"
#include "rook.h"
#include <vector>
#include <iostream>

/// @brief calculate a list of empty space coordinates needed for the move to be legal, assuming the move is possible
/// @param dest destination coordinates
/// @return a vector containing all coordinates to be verified
void rook::needed_space(coordinates dest, std::vector<coordinates> *to_calculate){
    if(dest.get_x() > piece::coord.get_x()){
        //Moving right
        for(int i = piece::coord.get_x() + 1; i < dest.get_x(); i++){
            to_calculate->push_back(coordinates(i,piece::coord.get_y()));
        }
    }
    if(dest.get_x() < piece::coord.get_x()){
        //Moving left
        for(int i = piece::coord.get_x() - 1; i > dest.get_x(); i--){
            to_calculate->push_back(coordinates(i,piece::coord.get_y()));
        }
    }
    if(dest.get_y() > piece::coord.get_y()){
        //Moving right
        for(int i = piece::coord.get_y() + 1; i < dest.get_y(); i++){
            to_calculate->push_back(coordinates(piece::coord.get_x(),i));
        }
    }
    if(dest.get_y() < piece::coord.get_y()){
        //Moving left
        for(int i = piece::coord.get_y() - 1; i > dest.get_y(); i--){
            to_calculate->push_back(coordinates(piece::coord.get_x(),i));
        }
    }
}

/// @brief print the piece to the standard output
void rook::print_piece(){
    if(piece::white){
        std::cout << "\u2656";
    }else{
        std::cout << "\u265C";
    }
}

/// @brief print the piece to the standard output in canonical form
void rook::canonical_print_piece(){
    if(piece::white){
        std::cout << "wR";
    }else{
        std::cout << "bR";
    }
}