#ifndef ROOK
#define ROOK
#include "../system/coordinates.h"
#include "../system/utilities.h"
#include "piece.h"
#include <vector>

/// @brief the rook piece class.
class rook : public piece{
    public:
        rook(bool _white, coordinates _coord):
            piece(_white,_coord)
            {
                type = rook_type;
                for(int i = -7; i < 8; i++)
                    if(i!=0){
                        legals.push_back(coordinates(0,i));
                        legals.push_back(coordinates(i,0));
                    }
            }
        void needed_space(coordinates dest, std::vector<coordinates> *to_calculate) override;
        void print_piece() override;
        void canonical_print_piece() override;
};

#endif